#include "ClassAVG.h"

/**
* Конструктор
*/
AVG::AVG(unsigned int d)
{
  if( d == 0 || d > DEPTH_AVG)depth = DEPTH_AVG;
  else depth = d;
  mas = (float *)malloc(sizeof(float)*depth);
  for( int i=0; i<depth; i++ )mas[i] = 0;
 
  first = true;
  cur   = 0;
}


/**
* Добавить значение в массив
*/
void AVG::Set(float x)
{
  if( first )
  {
     for( int i=0; i<depth; i++ )mas[i] = x;
     cur=0;
  }
  else
  {
     mas[cur++]=x;
     if( cur >= depth )cur=0;
  }
  first = false;  
}

/**
* Посчитать среднее значение
*/
float AVG::Get()
{
  float x=0;
  for( int i=0; i<depth; i++ )x+=mas[i];
  x/=depth;
  return(x);
}

/**
* Сравнить среднее значение с текущим с округлением до 1 знака
*/
int AVG::Compare(float x){
   float x1 = round(x*10);
   float x2 = round(Get()*10);
   if( x1 > x2 )return 1;
   if( x1 < x2 )return -1;
   return 0;
}

